Subject: Re: PIM-SM Join Latency

From: chan kwok hing <[email-masked]>
Date: Thu, 20 Apr 2000 00:43:41 +0800 (HKT)

Dear all,

	Thank you for Pavlin's help.

	Since I have modified the PIM-DM program to be able to run on
Linux, the performance is very good, the join latency varies between 0.1
second to 0.9 second, and no packet loss! However, it makes me suspect
that the PIM implementation has the problem resulting bad performance. Can
anyone tell me that is this still a problem in pimd-2.1.0-alpha28 PIM-SM
program? (Since I am using pimd-2.1.0-alpha26)

	According to the PIM-SM algorithm, for this situation (one router
and 2 subnetwork,  RP = DR), client join group should not have such great
delay. Please correct me if I am wrong. And please tell me that does the
program handle this situation? Thank you very much!

Regards,
Chan Kwok Hing

On Wed, 19 Apr 2000, Pavlin Ivanov Radoslavov wrote:

> >         Since we have tested on a Cisco 7500 using PIM-SM and MGEN, the
> > join latency varies between 0.025 secondes to 0.9 seconds, so what is the
> > main factor for this variation?
> 
> I think that the absolute value of this latency (< 1s) is small
> enough, so I don't think this variation really matters.
> 
> >         Also, we have downloaded the pimdd, but it has error message that
> > it has not the "pim.h" file when i compile with makefile. So can anyone
> > tell me how to solve it?
> 
> I think that pimdd has a directory "include" that contains
> subdirectories for different platforms. Unfortunately, there is no
> linux directory there. You can either adapt pim.h from the freebsd
> directory, or you can use the include/linux directory from pimd (but
> you need to edit the Makefile and add -Iinclude/linux to CFLAGS).
> 
> Pavlin
> 
> 
> > 
> > Thank you very much.
> > 
> > 
> > 
> > Regards,
> > Chan Kwok Hing
> > 
> > 
> > 
> > On Tue, 18 Apr 2000, Wilbert de Graaf wrote:
> > 
> > > Hi Chan,
> > > 
> > > IGMP is a (asymmetric) host-router protocol, so both router and host have
> > > their own characteristics concerning behaviour (pimd is the igmp querier,
> > > while linux's igmp.c is the reporter), timers and so on. For that reason
> > > pimd brings it's own implementation.
> > > 
> > > But you shouldn't change those defines in the headers since most of these
> > > are part of the protocol specs.
> > > 
> > > It's just that it sometimes helps to put logs in the sources when
> > > troubleshooting a protocol, so you can make sure what exactly is going on.
> > > 
> > > - Wilbert
> > > 
> > > ----- Original Message -----
> > > From: chan kwok hing <[email-masked]>
> > > To: Wilbert de Graaf <[email-masked]>
> > > Cc: <[email-masked]>
> > > Sent: Tuesday, April 18, 2000 8:59 PM
> > > Subject: Re: PIM-SM Join Latency
> > > 
> > > 
> > > > Dear all,
> > > >
> > > > Thank you for Graff's reply.
> > > >
> > > > Since the pimd program use dedicated igmp.c and igmpv2.h, not the
> > > > linux one (http://lxr.linux.no/source/net/ipv4/igmp.c), will it affect the
> > > > situation? Also, I have changed some parameter in igmpv2.h like
> > > > IGMP_QUERY_INTERVAL, IGMP_QUERY_RESPONSE_INTERVAL,
> > > > IGMP_STARTUP_QUERY_INTERVAL, etc. the performance looks a little better,
> > > > the join latency varies between 1.1 seconds to 9 seconds, but it seems not
> > > > reasonable. Looking forward to kindly reply. Thank you very much.
> > > >
> > > >
> > > >
> > > > Regards,
> > > > Chan Kwok Hing
> > > >
> > > >
> > > > On Tue, 18 Apr 2000, Wilbert de Graaf wrote:
> > > >
> > > > >
> > > > > Hi Chan,
> > > > >
> > > > > To start with thanks for the tip of MGEN. Dididn't know this
> > > application. I'm
> > > > > working on a IGMPv3 implementation myself, and it might be interested to
> > > do the
> > > > > same for the adaption of multicast source filters.
> > > > >
> > > > > Telling whether it's IGMP could be done using a packet trace on the
> > > client. You
> > > > > could detrmine how long it takes before the IGMPv2 leave report is
> > > transmitted
> > > > > after the last member-socket dropped membership. The source code of
> > > linux
> > > > > (http://lxr.linux.no/source/net/ipv4/igmp.c) seems to send the report
> > > right
> > > > > away so you shoudl be able to see that.
> > > > > Then of course there could be a delay within pimd, and you could change
> > > the
> > > > > source to log the events (when pimd received a leave report, and removed
> > > the
> > > > > outgoing interface list of the (S,G).
> > > > >
> > > > > Then, of course
> > > > >
> > > > >
> > > > >
> > > >
> > > 
> > > 
> 
>